
/******************************************************************************
* MODULE     : int_mod.gen.h
* DESCRIPTION: modular integers
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <tree.gen.h>

#module int_mod (p)
#import tree

#define characteristic<int_mod<p>> p
#if (p > 1000)
#define has_divisible<int_mod<p>>
#endif
#define Karatsuba_threshold<int_mod<p>> 16
#define FFT_threshold<int_mod<p>> 2400

struct int_mod<p> {
  int i;
  inline int_mod<p>  () { i=0; }
  inline int_mod<p>  (int i2) { i= i2%p; }
  inline int_mod<p>  (long long int i2) { i= i2%p; }
  inline int_mod<p>  (const int_mod<p>& i2) { i= i2.i; }
  inline int_mod<p>& operator = (int_mod<p> i2) { i= i2.i; return *this; }
  inline operator int () { return i; }
  operator string ();
  operator tree ();
};

ostream& operator << (ostream& out, int_mod<p> i);
int_mod<p> operator + (int_mod<p> i, int_mod<p> j);
int_mod<p> operator - (int_mod<p> i);
int_mod<p> operator - (int_mod<p> i, int_mod<p> j);
int_mod<p> operator * (int_mod<p> i, int_mod<p> j);
int_mod<p> operator / (int_mod<p> i, int_mod<p> j);

inline void operator += (int_mod<p>& i, int_mod<p> j) { i=i+j; }
inline void operator -= (int_mod<p>& i, int_mod<p> j) { i=i-j; }
inline void operator *= (int_mod<p>& i, int_mod<p> j) { i=i*j; }
inline void operator /= (int_mod<p>& i, int_mod<p> j) { i=i/j; }
inline void operator %= (int_mod<p>& i, int_mod<p> j) { i=i%j; }

#endmodule // int_mod (p)
